// -------------------------------------------------------------------
//                        ExWindow Ver.0.1.4
//           IplImageExImage\邽߂̃NX
// -------------------------------------------------------------------
// 
// ExWindow
// The MIT License
// Copyright (c) 2009 Sunao Hashimoto
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//
// ExWindow
// MITCZX
// Copyright (c) 2009 Sunao Hashimoto
//
// ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tg
// EFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ
// ŋ܂Bɂ́A\tgEFA̕gpAʁAύXAAfځA
// ЕzATuCZXA/܂͔̔錠Aу\tgEFA񋟂
// ɓƂ錠Ɋ܂܂܂B 
//
// L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
// ɋLڂ̂Ƃ܂B 
// 
// \tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ
// Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
// NQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B 
// ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tg
// EFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈
// Đ؂̐AQȂ̋`ɂĉ̐ӔCȂ
// Ƃ܂B 
//
//


#include "ExWindow.h"

//==========================================================================
// ̃\[XŗLȃO[oϐ
//==========================================================================
static const int g_win_full_offset_pos = -4;					// ̒ldvI
static const int g_full_offset_width   = 7;						// ̒ldvI
static const char *g_window_class_name = "Main HighGUI class";	// ̒ldvI


//-------------------------------------------------------------------------------------------------
// ftHgRXgN^
ExWindow::ExWindow(void)
{
	m_name[0] = '\0';
	m_flag = CV_WINDOW_AUTOSIZE;
}
//-------------------------------------------------------------------------------------------------
// RXgN^Q
ExWindow::ExWindow(const char *win_name, int flag)
{
	m_flag = flag;
	#if _MSC_VER < 1400
	// VC8.0Ȍꍇ
		strcpy( m_name, win_name );
	#else
		strcpy_s( m_name, sizeof(m_name), win_name );
	#endif

	cvNamedWindow(m_name,m_flag);
}
//-------------------------------------------------------------------------------------------------
// fXgN^
ExWindow::~ExWindow(void)
{
	cvDestroyWindow(m_name);
}
//-------------------------------------------------------------------------------------------------
// EBhEɖO
void ExWindow::SetName( const char *win_name, int flag)
{
	cvDestroyWindow(m_name);

	m_flag = flag;

	#if _MSC_VER < 1400
	// VC8.0Ȍꍇ
		strcpy( m_name, win_name );
	#else
		strcpy_s( m_name, sizeof(m_name), win_name );
	#endif

	cvNamedWindow( m_name, m_flag );
}
//-------------------------------------------------------------------------------------------------
// \ʒüړ
void ExWindow::Move(int px,int py) const
{
	cvMoveWindow(m_name, px, py);
}
//-------------------------------------------------------------------------------------------------
// EBhE̔j
void ExWindow::Destroy(void) const
{
	cvDestroyWindow(m_name);
}
//-------------------------------------------------------------------------------------------------
// tXN[
void ExWindow::SetFullScreen(void) const
{
	cvDestroyWindow(m_name);
	cvNamedWindow(m_name,0); // tXN[ɂ邽߂ɃtO:0im_flagɔfȂj

	int	 dispWidth = GetSystemMetrics(SM_CXSCREEN);		// ʉ𑜓x̎擾
	int	 dispHeight = GetSystemMetrics(SM_CYSCREEN);

	// EBhETicvGetWindowHandle()ƂȂ܂Ȃj
	#if _MSC_VER < 1400
	// VC8.0Ȍꍇ
		HWND hWnd = FindWindow(g_window_class_name, m_name);
	#else
		wchar_t win_name2[256];
		wchar_t class_name2[256];
		mbstowcs_s( NULL, win_name2, strlen(m_name) + 1, m_name, _TRUNCATE);
		mbstowcs_s( NULL, class_name2, strlen(g_window_class_name) + 1, g_window_class_name, _TRUNCATE);
		HWND hWnd = FindWindow( class_name2, win_name2 );
	#endif

	// EBhEX^C̕ύX
	SetWindowLong( hWnd, GWL_STYLE,WS_VISIBLE | WS_POPUP);

	// \ʒũZbgi_~[D킴ƈقȂݒj
	SetWindowPos( hWnd, HWND_TOP, 0, 0, dispWidth, dispHeight, SWP_SHOWWINDOW );

	// \ʒũZbgi{DȂƂ܂KpȂHj
	SetWindowPos( hWnd, HWND_TOP, g_win_full_offset_pos, g_win_full_offset_pos,
				  dispWidth + g_full_offset_width, dispHeight + g_full_offset_width,
				  SWP_SHOWWINDOW );
}
//-------------------------------------------------------------------------------------------------
// ʏTCY
void ExWindow::SetNormalSize(void) const
{
	cvDestroyWindow(m_name);
	cvNamedWindow(m_name,m_flag);
}
//-------------------------------------------------------------------------------------------------
// 摜̕\
void ExWindow::ShowImage(const IplImage *img) const
{
	cvShowImage( m_name, img );
}
//-------------------------------------------------------------------------------------------------
// w`l݂̂̕\
// channel = 0`3
void ExWindow::ShowSplitImage(const IplImage *imgIn, int channel) const
{
	IplImage *imgSplit = cvCreateImage( cvSize(imgIn->width,imgIn->height), imgIn->depth, 1 );

	if (channel==0)		 { cvSplit( imgIn, imgSplit, NULL, NULL, NULL ); }
	else if (channel==1) { cvSplit( imgIn, NULL, imgSplit, NULL, NULL ); }
	else if (channel==2) { cvSplit( imgIn, NULL, NULL, imgSplit, NULL ); }
	else if (channel==3) { cvSplit( imgIn, NULL, NULL, NULL, imgSplit ); }

	cvShowImage( m_name, imgSplit );
	cvReleaseImage( &imgSplit );
}
//-------------------------------------------------------------------------------------------------
