// -------------------------------------------------------------------
//                        ExWindow Ver.0.1.4
//           IplImageExImage\邽߂̃NX
// -------------------------------------------------------------------
// 
// ExWindow
// The MIT License
// Copyright (c) 2009 Sunao Hashimoto
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//
// ExWindow
// MITCZX
// Copyright (c) 2009 Sunao Hashimoto
//
// ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tg
// EFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ
// ŋ܂Bɂ́A\tgEFA̕gpAʁAύXAAfځA
// ЕzATuCZXA/܂͔̔錠Aу\tgEFA񋟂
// ɓƂ錠Ɋ܂܂܂B 
//
// L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
// ɋLڂ̂Ƃ܂B 
// 
// \tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ
// Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
// NQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B 
// ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tg
// EFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈
// Đ؂̐AQȂ̋`ɂĉ̐ӔCȂ
// Ƃ܂B 
//
//

#ifndef __EX_WINDOW_H__
#define __EX_WINDOW_H__

#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#pragma comment(lib,"cv.lib")
#pragma comment(lib,"cxcore.lib")
#pragma comment(lib,"highgui.lib")

// ExImageNXev[gi錾̂݁j
template <typename type> class ExImage;

// ExWindowNX
class ExWindow {

private:
	char m_name[512];	// EBhE
	int	 m_flag;		// \tO

public:

	// ftHgRXgN^
	ExWindow(void);

	// RXgN^Q
	ExWindow(const char *win_name,int flag = CV_WINDOW_AUTOSIZE);

	// fXgN^
	~ExWindow(void);

	// EBhEɖO
	void SetName( const char *win_name,int flag = CV_WINDOW_AUTOSIZE);

	// \ʒüړ
	void Move(int px,int py) const;

	// EBhE̔j
	void Destroy(void) const;

	// tXN[
	void SetFullScreen(void) const;

	// ʏTCY
	void SetNormalSize(void) const;

	// 摜̕\
	void ShowImage(const IplImage *img ) const;

	// w`l݂̂̕\
	// channel = 0`3
	void ShowSplitImage(const IplImage *img, int channel) const;

	// 摜̕\
	template <typename type> void ShowImage( ExImage <type> & imgIn) const {
		// ev[gȂ̂Ńwb_Ɏ
		cvShowImage( m_name, imgIn.Ipl() );
	}

	// w`l݂̂̕\
	// channel = 0`3
	template <typename type> void ShowSplitImage( ExImage <type> & imgIn, int channel) const {
		// ev[gȂ̂Ńwb_Ɏ
		IplImage *imgSplit = cvCreateImage( cvSize(imgIn.Width(),imgIn.Height()), imgIn.Depth(), 1 );

		if (channel==0)		 { cvSplit( imgIn.Ipl(), imgSplit, NULL, NULL, NULL ); }
		else if (channel==1) { cvSplit( imgIn.Ipl(), NULL, imgSplit, NULL, NULL ); }
		else if (channel==2) { cvSplit( imgIn.Ipl(), NULL, NULL, imgSplit, NULL ); }
		else if (channel==3) { cvSplit( imgIn.Ipl(), NULL, NULL, NULL, imgSplit ); }

		cvShowImage( m_name, imgSplit );
		cvReleaseImage( &imgSplit );
	}

};

#endif